package ru.dbotthepony.mc.otm.network;

import net.minecraft.network.FriendlyByteBuf;
import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.fml.DistExecutor;
import net.minecraftforge.fmllegacy.network.NetworkEvent;
import ru.dbotthepony.mc.otm.capability.IPatternStorage;
import ru.dbotthepony.mc.otm.menu.MatterPanelMenu;

import java.util.function.Supplier;

public record PatternReplicationRequestPacket(IPatternStorage.PatternState state, int how_much) {
	public PatternReplicationRequestPacket(IPatternStorage.PatternState state, int how_much) {
		this.state = state;
		this.how_much = Math.max(1, Math.min(99999, how_much));
	}

	public void encodeNetwork(FriendlyByteBuf buffer) {
		state.write(buffer);
		buffer.writeInt(how_much);
	}

	public void handleMessage(Supplier<NetworkEvent.Context> context) {
		context.get().setPacketHandled(true);

		context.get().enqueueWork(() -> {
			if (state == null)
				return;

			var ply = context.get().getSender();

			if (ply.containerMenu == null)
				return;

			if (!(ply.containerMenu instanceof MatterPanelMenu))
				return;

			((MatterPanelMenu) ply.containerMenu).requestReplication(ply, state, how_much);
		});
	}

	public static PatternReplicationRequestPacket decodeNetwork(FriendlyByteBuf buffer) {
		return new PatternReplicationRequestPacket(IPatternStorage.PatternState.read(buffer), buffer.readInt());
	}
}
